//Units utilises
#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <dos.h>
#include <math.h>

				/* TYPES */
typedef unsigned int  Entier;

enum Bool {false,true};

enum TEVENT { E_RIEN , E_CLIC , E_DOUBLECLIC , E_APP , E_MOVE , E_TOUCHE , E_EXIT} ;

struct TMsg
    {
     TEVENT Type;
     Bool Deplaced;
     char Touche;
     Entier X;
     Entier Y;
     Entier DepX;
     Entier DepY;
	};

enum TMessage { M_Aff, M_Agr, M_Dim, M_Hide, M_Act, M_NotAct, M_Paint,M_Sel,
  M_Close };

enum TAction { A_Rien , A_New , A_Change , A_Move , A_EXIT };

			 /* CONSTANTES */
const unsigned short int nil=0;
const unsigned short int MAX=5;

//Liste des fenetres visibles
   Entier File[MAX];

		     /* VARIABLES GLOBALES */

Entier   NFenetre=0  //nombre de fenetres cres
	 ,   NAct=0  //nombre de fenetres visibles
	 ,indexAct=0;//index de la fenetre active
Bool Selection=false,Appuye=false ,QUIT=false;

			  /* CLASSES */

		    /*     Classe TMenu     */
class TMenu
{
  public:
       TMenu() {textbackground(WHITE);
		window(1,25,80,25);clrscr();
		buffer =new char[80*2];
		 N=1;
		Dessiner();
		Normale=true;
		};
       ~TMenu() { delete(buffer); };

       void AddMenu(Entier index);
       void ChangeMenu(Entier index,Entier C) ;
       void DeleteMenu(Entier index);
       Bool GestionMessage(TMsg Msg);
  private:
       void Message (TAction A,Entier index=99);
       Entier Numero(Entier X);
       Entier Position(Entier X);
       Bool OnFrole   (Entier x,Entier &index);
       Bool OnNonFrole(Entier x,Entier index);
       Entier N;
       Entier Num[MAX+1];
       Bool Normale;
       Entier Item;
       char* buffer;
       void Dessiner() ;
       void DessinerItem(Entier M=99);
};

		/*     Classe TFenetre     */
class  TFenetre
 {
    public:
      TFenetre();
      ~TFenetre();
    /*  	Proprits Publiques  		*/
      Entier index;      //  Numero de la fenetre
			 //  Etat de la fenetre :
      Bool Active;       //    		Actif
      Bool Visible;      //    		Visible
      Bool Select;       //    		Selectionn pour le deplacement
      Bool DimSelect;    //    		Selectionn pour le dimmensionnement
      Entier Left() const { return(X); }
      Entier Top()  const { return(Y); }
      Entier Larg() const { return(Lg); }
      Entier Haut() const { return(Ht); }
      char Titre[20];
   /*            Mthodes  Publiques 		*/
      void Afficher();
      void Cacher();
      void Activer();
      void Desactiver();
      void Agrandir();
      void Diminuer();
      void Dessiner();
    /*  	Mthode de gestion des mssages		*/
      Bool GestionMessage(TMsg Msg);

    private:

     /*            Mthodes   Prives 		*/
      void Selectionner();
      void Deplacer(signed int Dx,signed int Dy);
      void DimSelectionner();
      void Dimensionner(signed int Dx,signed int Dy);
      void Change();
      void EcrireCaractere(char Caractere);
      void EnregTexte();
      void AfficherTexte();
      void Message(TMessage M);
      void Cadre(Entier CouleurTitre) ;

   /*          Evenements lis  la fenetre          */
      Bool OnFroleBarreTitre(Entier X,Entier Y); //Non Utilise
      Bool OnClic    (Entier X,Entier Y);
      Bool OnFerme   (Entier X,Entier Y);
      Bool OnAgrandi (Entier X,Entier Y);
      Bool OnReduit  (Entier X,Entier Y);
      Bool OnSelected(Entier X,Entier Y);
      Bool OnDimSelected(Entier X,Entier Y);
      Bool OnFrole   (Entier X,Entier Y);
   /*               Proprits  PRIVEES            */
      Entier Type;
      Entier DimType;
      Bool Normale;
      Bool Grande;
      Bool Creating;

      Entier X,Y,Ht,Lg;
      Entier Couleur,CouleurFond;
      Entier x,y,l,h;
      char *bufferCadre,*bufferErase,*buffer;
   };

		/* Tableau de POINTEURS vers TFenetre */

TFenetre* Fenetres[MAX] ={nil,nil,nil,nil,nil};

			/* VARIABLES */
TMenu* Menu;

		       /* PROCEDURES */

		     /* SECTION INTERFACE */
/*Procedure de TEST des erreurs*/
void Test()
{ Entier i;
  i=NAct-1;
  textbackground(BLACK);
  textcolor(WHITE);
  window(1,1,80,1);
  clrscr();
  while  (i+1>0)
  {
  //TFenetre &Fen=*Fenetres[ File[i] ];
  printf( "File(%d)=%d,",i,File[i] );
  i--;
  }
  i=i;
   /*textbackground(BLACK);
   clrscr();*/
}

/*Interface des messages destins aux fenetres*/
void MessageInterface(Entier i,TMessage DMessage);

		/* Boites de messages */
void ShowMessage(TMsg Msg);  void Erreur(char *chaine);

/*Redessine les fenetres visibles*/
void ToutDessiner();

/* Procedure de cration de la fenetre */
void CreerFenetre();

/* Positionne le curseur o on a cliqu */
void GotoXY(Entier x,Entier y);

/* Procedure d'initialisation */
void Init();

/*Initialiser la souris*/
void InitSouris();

/* Vrifie si on a fait un clic gauche avec la souris */
Bool OnClicGauche(Entier &X,Entier &Y);

/* verifie si on a boug la Souris */
Bool OnMouseMove(Entier &X,Entier &Y,signed int &Dx,signed int &Dy);

/* placer le curseur  l'endroit spcifi */
void PlacerCurseur(signed int Dx,signed int  Dy);

		 /* Gestion de la liste des fenetres visibles */

void Defiler(Entier M);  void Permut(Entier M);


		 /* SECTION IMPLEMENTATION */

void TFenetre::EcrireCaractere(char Caractere)
{
  Entier CarX,CarY;
  CarX=wherex();
  CarY=wherey();
  if (Caractere>='!' && Caractere<='~')
  {   putch(Caractere);
      if (CarX==Larg()) gotoxy(2,CarY+1);
   }else
  switch (Caractere)
   {
    case 13:{gotoxy(2,CarY+1);insline();Cadre(YELLOW);gotoxy(2,CarY+1);break;}
    case 0 :{Caractere=getch();
	       switch (Caractere)
		{
		  case 77:{if ( CarX<Larg() ) gotoxy(CarX+1,CarY);  break;};
		  case 75:{if (    CarX>2   ) gotoxy(CarX-1,CarY);  break;};
		  case 72:{if ( CarY>2      ) gotoxy(CarX , CarY-1);break;};
		  case 80:{if ( CarY<Haut() ) gotoxy(CarX , CarY+1);break;};
		}
	     break;}

   };
}

Bool TFenetre::GestionMessage(TMsg Msg)
{ Bool Traitee=true;
  if  (Msg.Type==E_TOUCHE)
      {
       EcrireCaractere(Msg.Touche);

      } else
  if  (Msg.Type==E_MOVE) {/*if ( FroleBarreTitre(Msg.X,Msg.Y) )   { */
				if ( Normale &&  OnFrole(Msg.X,Msg.Y)  )
			     Change();   else
				if (Normale==false)/*&&( Frole(Msg.X,Msg.Y)==false ) */
			     Change();
			  /*else Traitee=false; */
			     }
	  else
  if (Msg.Type==E_DOUBLECLIC)
    {if ( OnFroleBarreTitre(Msg.X,Msg.Y) )   { Message(M_Agr);Traitee=true; } }

      else
  if (Msg.Type==E_CLIC)
    if ( Select==true )  //Si fenetre est selectionne
	 {
	   Select=Selection=false;
	   MessageInterface(indexAct,M_Paint);
	 }  else
    if (DimSelect==true )
	 {
	   DimSelect=Selection=false;
	   delete(bufferCadre);	bufferCadre = new char[(Lg+1)*(Ht+1)*2];
	   delete(bufferErase); bufferErase = new char[(Lg+1)*(Ht+1)*2];
	   textbackground(BLACK); window(X,Y,X+Lg,Y+Ht);clrscr();
	   gettext(X,Y,X+Lg,Y+Ht,bufferErase);//pour l'effacement lors d'un deplacement de la fenetre
	   MessageInterface(indexAct,M_Paint);
	 }  else
    if ( OnClic   (Msg.X,Msg.Y) )     {   Message(M_Act);

	if ( OnFerme  (Msg.X,Msg.Y) ) 	Message(M_Close);else
	if ( OnAgrandi(Msg.X,Msg.Y) ) 	Message(M_Agr);  else
	if ( OnReduit (Msg.X,Msg.Y) )
	Message(M_Hide); else
	   GotoXY(Msg.X,Msg.Y);//Positionner le curseur la o on a cliqu
	  }
    else Traitee=false;   else

  if (Msg.Type==E_APP)
    if  (Select)  { if ( Msg.Deplaced )  Deplacer(Msg.DepX,Msg.DepY);}
    else
    if  ( Select==false && OnSelected(Msg.X,Msg.Y)  )/*si la fenetre est  selectionne pour la premire fois*/
	       {Selectionner();Selection=true;Traitee=true; /*ShowMessage(Msg);*/} else

    if ( DimSelect ) { if ( Msg.Deplaced )
    Dimensionner(Msg.DepX,Msg.DepY);}
    else
    if ( OnDimSelected(Msg.X,Msg.Y) )
	    {DimSelectionner();Selection=true;Traitee=true;}
  return Traitee;
}

void TFenetre::Message(TMessage Msg)
{
  switch(Msg)
  {
   case M_Act:   {Activer();      break;}
   case M_Hide:  {Cacher();       break;};
   case M_NotAct:{Desactiver();   break;}
   case M_Agr:   {Agrandir();     break;};
   case M_Dim:   {Diminuer();  	  break;};
   case M_Paint: {Dessiner();     break;};
   case M_Sel:   {Selectionner(); break;};
   case M_Close:{ Entier i=index;
		  delete Fenetres[i]; Fenetres[i]=nil;break;};
   }
}

void TFenetre::Dessiner()
{
	asm {mov ax,02;int 0x33};//masquer le curseur de la souris

	textbackground(CouleurFond);	textcolor(Couleur);

	if (Selection==false)
	{  window(X, Y, X+Lg, Y+Ht);clrscr();gotoxy(1,1);}

	if (Active==true) Cadre(YELLOW);
	else   puttext(X,Y,X+Lg,Y+Ht, bufferCadre);
	//if (Creating==false) AfficherTexte();
	gotoxy(2,2);

	asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void TFenetre::Agrandir()
{
	if (Grande!=true)
	{
	x=X; y=Y; l=Lg; h=Ht;
	X=1;Y=1;Lg=79;Ht=23;
	Grande=true;
	//rallouer de l'espace mmoire pour la fenetre agrandie
	delete(bufferCadre); bufferCadre = new char[(Lg+1)*(Ht+1)*2];
	delete(buffer);      buffer = new char[(Lg+1)*(Ht+1)*2];
	Dessiner();
	gotoxy(2,2);
	}
	else Diminuer();

}

void TFenetre::Diminuer()
{
	if (Grande==true)
	{
	X=x ;Y=y ;Ht=h ;Lg=l;
	Grande=false;
	asm {mov ax,02;int 0x33};//masquer le curseur de la souris
	textbackground(BLACK);  clrscr(); //effaer l'cran
	asm {mov ax,01;int 0x33;}//rafficher le curseur

	delete(bufferCadre);bufferCadre = new char[(Lg+1)*(Ht+1)*2];
	ToutDessiner();
	MessageInterface(indexAct,M_Paint); //elle va tre appele lors de la dselection
	}
}

void TFenetre::Cacher()
{       asm {mov ax,02;int 0x33};//masquer le curseur de la souris
	textbackground(BLACK);
	window(X, Y, X+Lg, Y+Ht);
	clrscr(); //effaer l'cran

	Visible=false;
	Active=false;

	Defiler(index);
	(*Menu).ChangeMenu(index+1,BLACK);

	if (NAct>1) ToutDessiner();
	if (NAct>0) MessageInterface(File[NAct-1],M_Act);
	else {indexAct=-1; _setcursortype(_NOCURSOR);}
	asm {mov ax,01;int 0x33;}//rafficher le curseur
}


void TFenetre::Afficher()
{       if (Visible==false)
	{
	  Visible=true;
	  Dessiner();
	  NAct++;
	  File[NAct-1]=index;
	  if (Creating) Creating=false;
	}
	else {Dessiner();
	      if (Creating) Creating=false;else
	      if (NAct>1) Permut(index);
	      }
}

void TFenetre::Activer()
{
    if (Active==false)
    {
     if (NAct>0) MessageInterface( indexAct ,M_NotAct);
     Active = true;
     indexAct = index;
     (*Menu).ChangeMenu(index+1,YELLOW);
     if (Creating) {textbackground(BLACK);
		    window(X,Y,X+Lg,Y+Ht);clrscr();
		    gettext(X,Y,X+Lg,Y+Ht,bufferErase);
		   }
     Afficher();
    }
}

void TFenetre::Desactiver()
{
	if (Active==true)
       {
	Active=false;
	asm {mov ax,02;int 0x33};//masquer le curseur de la souris
	//EnregTexte();
	puttext(X,Y,X+Lg,Y+Ht,bufferCadre);
	//AfficherTexte();
	(*Menu).ChangeMenu(index+1,WHITE);
	asm {mov ax,01;int 0x33;}//rafficher le curseur
       }
}

void TFenetre::Cadre(Entier C)
{
	Entier i;
	Entier L = Lg-3-strlen(Titre)-3-6;
	_setcursortype(_NOCURSOR);
	gotoxy(1,1);
	cprintf("");
	cprintf("[");textcolor(BROWN);cprintf("");textcolor(WHITE);cprintf("]");
	for(i=1;i<=L;i++) if ( i== (L/2)+2) cprintf(" %s%d ",Titre,index+1);
			  else cprintf("");
	cprintf("[");textcolor(GREEN);cprintf("%c",22);textcolor(WHITE);cprintf("]");
	cprintf("[");textcolor(GREEN);cprintf("%c",18);textcolor(WHITE);cprintf("]");
	cprintf("");

	for(i=1;i<Ht;i++) { cprintf("");gotoxy(Lg+1,i+1); cprintf(""); }
	cprintf(""); for(i=0;i<=Lg-2;i++) cprintf(""); printf("");

	if (gettext(X,Y,X+Lg,Y+Ht,bufferCadre)!=1) Erreur("erreur de buffer");

	if (C==YELLOW)
	      {L = Lg-strlen(Titre);gotoxy(L/2,1);
	       textcolor(C);cprintf(" %s%d ",Titre,index+1);textcolor(WHITE);
	      };
	_setcursortype(_NORMALCURSOR);

}

void TFenetre::Selectionner()
{
      Select=true;
      Entier i;
	asm {mov ax,02;int 0x33};//masquer le curseur de la souris
	textcolor(LIGHTGREEN);
	textbackground(BLUE);
	window(X,Y,X+Lg,Y+Ht);
	gotoxy(1,1);
	_setcursortype(_NOCURSOR);
	cprintf("");

	for(i=1;i<=Lg-1;i++)  cprintf("");

	cprintf("");
	for(i=1;i<Ht;i++) { cprintf("");gotoxy(Lg+1,i+1); cprintf(""); }
	cprintf("");
	for(i=0;i<=Lg-2;i++) cprintf(""); printf("");
	textcolor(WHITE);
	if (gettext(X,Y,X+Lg,Y+Ht,bufferCadre)!=1) Erreur("erreur de buffer");
	//EnregTexte();
	asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void TFenetre::Deplacer(signed int Dx,signed int Dy)
{ signed int x=X+Dx,y=Y+Dy;
 asm {mov ax,02;int 0x33};//masquer le curseur de la souris
 if ( Grande==false &&  x+Lg<=80  &&  y+Ht<25  &&  x>0 &&  y>0 )
 {
  /*textbackground(BLACK);
  window(X,Y,X+Lg,Y+Ht);
  clrscr();*/
  puttext(X,Y,X+Lg,Y+Ht,bufferErase);
  X=X+Dx ; Y=Y+Dy ;
  if (NAct>1) ToutDessiner();
  puttext(X,Y,X+Lg,Y+Ht,bufferCadre);
  //AfficherTexte();
 }
 asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void TFenetre::DimSelectionner()
{
      DimSelect=true;
      Entier i;
	asm {mov ax,02;int 0x33};//masquer le curseur de la souris
	textcolor(YELLOW);
	textbackground(BLUE);
	window(X,Y,X+Lg,Y+Ht);clrscr();
	gotoxy(1,1);
	_setcursortype(_NOCURSOR);
	cprintf("");

	for(i=1;i<=Lg-1;i++)  cprintf("");

	cprintf("");
	for(i=1;i<Ht;i++) { cprintf("");gotoxy(Lg+1,i+1); cprintf(""); }
	cprintf("");
	for(i=0;i<=Lg-2;i++) cprintf(""); printf("");
	textcolor(WHITE);
	//if (gettext(X,Y,X+Lg,Y+Ht,buffer)!=1) Erreur("erreur de buffer");
	asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void TFenetre::Dimensionner(signed int Dx,signed int Dy)
{
 asm {mov ax,02;int 0x33};//masquer le curseur de la souris

 if ( Grande==false && (X+Dx+Lg<=80 && Dx+Lg>=40) && (Y+Dy+Ht<25 && Dy+Ht>=10) )
 {
  textbackground(BLACK);  window(X,Y,X+Lg,Y+Ht);   clrscr();
  switch (DimType)
  {
  case 1 :{ Lg=Lg+Dx ; break;};
  case 2 :{ Ht=Ht+Dy ; break;};
  case 3 :{ Lg=Lg+Dx ;Ht=Ht+Dy ; break;};
  }
  if (NAct>1) ToutDessiner();
  DimSelectionner();
 }
 //else PlacerCurseur(Dx,Dy);
  asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void TFenetre::EnregTexte()
{
  gettext(X+1,Y+1,X+Lg-1,Y+Ht-1 ,buffer);
  puttext(X+1,Y+1,X+Lg-1,Y+Ht-1 ,buffer);
}
void TFenetre::AfficherTexte()
{
   puttext(X+1,Y+1,X+Lg-1,Y+Ht-1 ,buffer);
}

void TFenetre::Change()
{ int Col;
  asm {mov ax,02;int 0x33};//masquer le curseur de la souris
  _setcursortype(_NOCURSOR);
  window(X,Y,X+Lg,Y+Ht);
  textbackground(CouleurFond);

  if (Normale) { Col=YELLOW;Normale=false;}
  else         { Col=WHITE; Normale=true ;}

  textcolor(Col);
  switch (Type)
  {
   case 1:{  gotoxy( 2 , 1 );
	     cprintf("[");textcolor(BROWN);
	     cprintf("");textcolor(Col);
	     cprintf("]");	 break;}

   case 2:{  gotoxy( Larg() -5, 1 );
	     cprintf("[");textcolor(GREEN);
	     cprintf("%c",22);textcolor(Col);
	     cprintf("]");	break;}

   case 3:{  gotoxy( Larg() -2, 1 );
	     cprintf("[");textcolor(GREEN);
	     cprintf("%c",18);textcolor(Col);
	     cprintf("]");	break;}
   }

  asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

Bool TFenetre::OnFroleBarreTitre(Entier X,Entier Y)
{
   Entier  Xinf;//(Xinf,Yinf)=point inferieur gauche
   Bool Trouve;

    Xinf= Left()+Larg();

   if (  X>=Left()  &&  X<=Xinf  &&  Y==Top() ) Trouve=true;
   else Trouve=false;

  return Trouve;
}

Bool TFenetre::OnFrole(Entier X,Entier Y)
{
   Bool Trouve=false;
   if ( Y==Top() )
   if (X==Left() + 2) 	      {Type=1;Trouve=true;} else
   if (X==Left() + Larg() -5) {Type=2;Trouve=true;} else
   if (X==Left() + Larg() -2) {Type=3;Trouve=true;}

   return Trouve;
}

Bool TFenetre::OnClic(Entier X,Entier Y)
{
  Entier  Xinf,Yinf;//(Xinf,Yinf)=point inferieur gauche
  Bool Trouve=false;

   Xinf= Left()+Larg();
   Yinf= Top()+ Haut();

   if ( X>=Left()  &&  X<=Xinf  &&  Y>=Top()  &&  Y<=Yinf ) Trouve=true;
   else Trouve=false;

  return Trouve;
}

Bool TFenetre::OnFerme(Entier X,Entier Y)
{
   Entier XFer,YFer;
   Bool Trouve=false;

	XFer = Left()+2,
	YFer = Top();
	if ( XFer==X  &&  YFer== Y ) Trouve=true;
	else Trouve=false;

   return Trouve;
}

Bool TFenetre::OnAgrandi(Entier X,Entier Y)
{
   Entier XAgr,YAgr;
   Bool Trouve=false;

	XAgr= Left() + Larg() -2;
	YAgr= Top();
	if ( XAgr==X  &&  YAgr==Y ) Trouve=true;
	else Trouve=false;

   return Trouve;
   }

Bool TFenetre::OnReduit(Entier X,Entier Y)
{
   Entier XRed,YRed;
   Bool Trouve=false;

	XRed = Left()+Larg() -5;
	YRed = Top();
	if ( XRed==X  &&  YRed== Y ) Trouve=true;
	else Trouve=false;

   return Trouve;
   }

Bool TFenetre::OnSelected(Entier X,Entier Y)
{
  Bool Trouve=false;
  Entier L,top,left,i;
  if (Selection==false)
  {
   L= Left() + Larg();
   top = Top();     left = Left();
     if ( Y==top  &&  X>=left  &&  X<=L  )
     if ( OnFerme(X,Y)==false &&  OnAgrandi(X,Y)==false && OnReduit(X,Y)==false  )
      Trouve=true;
      }
  return Trouve;
}

Bool TFenetre::OnDimSelected(Entier X,Entier Y)
{
  Bool Trouve=true;
  Entier H,L;
   if (Selection==false)
   {
   H= Top() + Haut();   L=Left()+Larg();

   if ( X==L  &&  Y>Top()  &&  Y<H  )   DimType=1;else
   if ( Y==H  &&  X>Left() &&  X<L  )   DimType=2;else
   if ( X==L  &&  Y==H )                DimType=3;else
   Trouve = false;
  }
  else Trouve =false;
  return Trouve;
}

			/*Constructeur de TFenetre*/
TFenetre::TFenetre()
{  if (NFenetre==0)
	{ X=4;Y=2; }//Si c'est la premire fenetre
   else
	{Entier x,y;
	 TFenetre   &Fen=*Fenetres[ indexAct ];
	 x= Fen.Left() +5;
	 y= Fen.Top() ;
	 div_t T;
	 T=div(x,40);
	 X=T.rem;
	 T=div(y,14);
	 Y=T.rem +1 ;
       };
   Lg=40;  Ht=10;
   CouleurFond=BLUE;Couleur=WHITE;
   NFenetre++;
   l=strlen("Ma Fenetre");
   strncpy(Titre,"Ma Fenetre",l );Titre[l]='\0';
   Active=false;
   Visible=false;
   Grande=false;
   Select=false;
   DimSelect=false;
   Creating=true;
   Normale=true;
   bufferCadre =new char[(Lg+1)*(Ht+1)*2];//buffer de stockage du texte de la fenetre
   bufferErase =new char[(Lg+1)*(Ht+1)*2];
   buffer     = new char[(Lg-1)*(Ht-1)*2];
}

			/*Destructeur de TFenetre*/
TFenetre::~TFenetre()
  {
    Cacher();//cacher la fenetre  fermer
    NFenetre--;
    (*Menu).DeleteMenu(index+1);
    delete(bufferCadre);delete(bufferErase);delete(buffer);
   }

void GotoXY(unsigned int X,unsigned int Y)
{
  TFenetre &Fen=*Fenetres[ indexAct ];
  Entier  Xinf= Fen.Left()+Fen.Larg(),
	  Yinf= Fen.Top()+Fen.Haut();//(Xinf,Yinf)=point inferieur gauche
  if ( X>Fen.Left()  &&  X<Xinf  &&  Y>Fen.Top()  &&  Y<Yinf  )
  gotoxy(X-Fen.Left()+1,Y-Fen.Top()+1);


}

void Init()
{
       textbackground(BLACK);
       textcolor(WHITE);
       clrscr();
       InitSouris();
       Menu=new(TMenu);
       _setcursortype(_NOCURSOR);
}

Bool  TMenu::OnFrole(Entier x,Entier &Pos)
{ Bool Result=false;

  if (Normale)
  if ( x>=1  &&  x<20 ) {Pos=9 ;Result=true; }else
  {   Pos= (*Menu).Position(x);   if (Pos!=0)
  Result=true;  };

  return Result;
}

Bool  TMenu::OnNonFrole(Entier x,Entier Pos)
{
   Bool Result=false;

   Entier base=20+( Pos -1 )*11;
    if (Pos==32) {if (x<76) Result=true;} else
    if (Pos==9) {if (x>=19) Result=true;} else

    if ( x<base  ||  x>=base+10 )
    Result=true;

  return Result;
}

Bool TMenu::GestionMessage(TMsg Msg)
{
  Entier M,Pos;     Bool Traitee=true;

  if (Msg.Type==E_MOVE) { if ( Normale &&  Msg.Y==25 &&  OnFrole(Msg.X,Pos)  )
			   DessinerItem(Pos);  else
			  if ( Normale==false && ( Msg.Y<=24 || OnNonFrole(Msg.X,Item) )   )
			   DessinerItem();
			   Traitee=false;} else

  if ( Msg.Type==E_CLIC && Msg.Y==25 )

	if ( Msg.X>=2  && Msg.X<=17 ) Message(A_New); else
	if ( Msg.X>=76 && Msg.X<80  ) Message(A_EXIT);else
	{ M=Numero(Msg.X) ; if ( M!=0)Message(A_Change,M);  }

  else  Traitee=false;

  return Traitee;
}

void TMenu::Message(TAction Action,Entier M)
{
  switch (  Action    )
{
case A_New:   { CreerFenetre();     break;}  /* Creer une nouvelle fenetre */
case A_Change:{ MessageInterface(M-1,M_Act); break;}/* Changer la fenetre active  */
case A_EXIT:  { QUIT=true;    break;} /* Quitter l'application  */
}

}

void TMenu::DessinerItem(Entier Pos)
{
      if (Pos==99) {
      puttext(1,25,80,25,buffer);Normale=true; }
      else {
      Entier C;
      asm {mov ax,02;int 0x33};//masquer le curseur de la souris

      if (Pos!=9)
		{char fen[15];
		 Entier base=20+(Pos-1)*11;
		 if (Pos==32){
		 base =76;
		 textbackground(LIGHTGRAY);
		 window(1,25,80,25);Item=Pos;
		 gotoxy(base,1);
		 textcolor(BLUE);cprintf("Quit");
		 Normale=false;
		 }else {
		 if ( (*Fenetres[Num[Pos]-1]).Active)  C=YELLOW;else
		 if ( (*Fenetres[Num[Pos]-1]).Visible) C=WHITE; else
						    C=BLACK;
		 Item=Pos;
		 textbackground(LIGHTGREEN);
		 window(1,25,80,25);
		 gotoxy(base,1);
		 sprintf(fen,"%s%d","Fenetre ",Num[Pos]);
		 textcolor(C); cprintf("%s ",fen);
		 Normale=false;  }
		 } else
		{Item=Pos;
		 textbackground(LIGHTGREEN); textcolor(LIGHTBLUE);
		 window(1,25,80,25);
		 gotoxy(1,1);cprintf(" Nouvelle fenetre ");
		 Normale=false;}

       asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
		 _setcursortype(_NOCURSOR);
	}
}

void TMenu::Dessiner()
{
   Entier i;  char  fen[15];
   asm {mov ax,02;int 0x33};//masquer le curseur de la souris
   textbackground(WHITE);textcolor(LIGHTBLUE);
   window(1,25,80,25);clrscr();
   gotoxy(1,1);
   cprintf(" Nouvelle fenetre");
   textcolor(BLACK);cprintf(" |");

   gotoxy(20,1);
   for(i=1;i<N;i++)
   {   TFenetre &Fen=*Fenetres[Num[i]-1];
       sprintf(fen,"%s%d","Fenetre ",Num[i]);
       if (Fen.Active)  textcolor(YELLOW);else
       if (Fen.Visible) textcolor(WHITE); else
			textcolor(BLACK);
       cprintf(fen);
       textcolor(BLACK);cprintf(" |");
   };
   gotoxy(76,1);textcolor(RED);
   cprintf("Quit");
   gettext(1,25,80,25,buffer);
   asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
   _setcursortype(_NOCURSOR);
}

void TMenu::AddMenu(Entier index)
{
       Num[N]=index;
       N++;
       Dessiner();
 };

void TMenu::ChangeMenu(Entier index,Entier C)
{
      Entier i=1;
      Bool Trouve=false;

      while ( (i<N)&&(Trouve==false) )
      if (Num[i]==index) Trouve=true;  else i++;

      if (Trouve)
		{char fen[15];
		 Entier base=20+(i-1)*11;
		 asm {mov ax,02;int 0x33};//masquer le curseur de la souris
		 textbackground(WHITE);
		 window(1,25,80,25);
		 puttext(1,25,80,25,buffer);
		 gotoxy(base,1);
		 sprintf(fen,"%s%d","Fenetre ",index);
		 textcolor(C); cprintf("%s ",fen);
		 gettext(1,25,80,25,buffer);
		 if (Normale==false) DessinerItem(Item);

		 asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
		 };
};

void TMenu::DeleteMenu(Entier index)
{
    Entier i=1;	   Bool Trouve=false;
    while ( i<N && Trouve==false )
    if (Num[i]==index) Trouve=true;  else i++;

    if (Trouve==true)
	  {for (i;i<N-1;i++) Num[i]=Num[i+1];
	   N--;
	   Dessiner();}
    else  Erreur(" Erreur de menu ");//ne devrait jamais arriver
};

Entier TMenu::Position(Entier X)
{ Entier Result,T; Result=false;
    T=X-19;
    if (X>75) Result=32; else
    if (T%11!=0)//si non clic sur les barres verticales
     { T=T/11+1;
       if (T>=N) T=0;
       Result=T;
     }
  return Result;
};

Entier TMenu::Numero(Entier X)
{ Entier Result,T; Result=false;
    T=X-19;
    if (T%11!=0)//si non clic sur les barres verticales
     { T=T/11+1;
       if (T<N) T=Num[T];
	else T=0;
       Result=T;
     }
  return Result;
};

void Defiler(Entier M)
{ Bool T=false;
  Entier i=NAct-1;
    do
    if (File[i]==M) T=true;
    else i--;
    while ( T==false && i+1>0 );

    if (i+1==0) Erreur("erreur dans la proc. Defiler()");

  for (i;i<NAct-1;i++) File[i]=File[i+1];
  NAct--;
};

void Permut(Entier M)
{
  Bool T=false;
  Entier i=NAct-1;
  //Test();
  while ( T==false  &&  i+1>0 )
    if (File[i]==M) T=true;
    else i--;
  if (i+1==0) { Erreur("erreur dans la proc. Permut()");
  Test();}
  for (i;i<NAct-1;i++) File[i]=File[i+1];
  File[NAct-1]=M;
}

void ShowMessage(TMsg Msg)
{
  asm {mov ax,02;int 0x33};//masquer le curseur de la souris
  textbackground(BLACK);
  textcolor(WHITE);
  window(1,1,80,1);
  clrscr();
  _setcursortype(_NOCURSOR);
  /*Entier i;
  for (i=0;i<MAX;i++)
	 if (Fenetres[i]==nil) printf("fenetres[%d]=nil ",i+1);  else
	 printf("fenetres[%d]=obj ",i+1); */
  switch (Msg.Type)
  {
  case E_MOVE:{printf("Type message=MOVE X=%d ,Y=%d",Msg.X,Msg.Y);break;};
  case E_CLIC:{printf("Type message=CLIC,non appuy, X=%d ,Y=%d",Msg.X,Msg.Y);
	  break;}
  case E_APP: {printf("Type message=APP,appuy, X=%d ,Y=%d",Msg.X,Msg.Y);
		break;};
		};
  asm {mov ax,01;int 0x33;};//afficher le curseur de la souris
}

void Erreur(char* chaine)
{
  textbackground(LIGHTGRAY);
  textcolor(RED+BLINK);
  window(25,7,55,12);
  clrscr();
  gotoxy(8,3);
  _setcursortype(_NOCURSOR);
  cprintf(chaine);getch();
  textbackground(BLACK);
  clrscr();
  if (NFenetre>0) {ToutDessiner();
		   MessageInterface(indexAct ,M_Paint ); }

}

		/* GESTION DE LA SOURIS */

void InitSouris()
{
 asm {
      //initialiser la souris
     mov ax, 0
     int 0x33
     cmp ax,-1
     jnz Eti
      //afficher le curseur de la souris
     mov ax,1
     int 0x33
     }
     Eti:
}

Bool OnClicGauche(unsigned int &X,unsigned int &Y)
{
 Bool Gauche=false;
 Entier xvir,yvir;
 div_t Div;

 if (Appuye==false)
  {     asm {mov ax,3
	     int 0x33
	     cmp bx,1
	     jnz Eti
	     mov DS:[xvir],cx
	     mov DS:[yvir],dx
	     }
	Appuye=true;           //est ce que bouton appuye
  }
 else { asm { mov ax,3
	     int 0x33
	     cmp bx,0
	     jnz Eti
	     mov DS:[xvir],cx
	     mov DS:[yvir],dx
	    };
       Appuye=false;
       Gauche=true;
      }

  Div=div(xvir,8);   X=Div.quot +1;
  Div=div(yvir,8);   Y=Div.quot +1;
  Eti:return Gauche;
}

Bool OnMouseMove(Entier &X,Entier &Y,signed int &Dx,signed int &Dy)
{ Bool Move=false;
  Entier x,y,xvir,yvir;
  div_t Div;
 asm {
     mov ax,3
     int 0x33
     mov DS:[xvir],cx
     mov DS:[yvir],dx
 };
  Div=div(xvir,8);   x=Div.quot +1;
  Div=div(yvir,8);   y=Div.quot +1;
  Dx=x-X ; Dy=y-Y ;
    if ( (Dx!=0)||(Dy!=0) ) {
    Move=true;X=x;Y=y; }

 return Move;
}

void PlacerCurseur(signed int Dx,signed int  Dy)
{
 Entier xvir,yvir;
 signed int X,Y;
 X=(Dx) *8;
 Y=(Dy) *8;
 asm {
      MOV AX,0x03
      int 0x33
      MOV DS:[X],CX
      MOV DS:[Y],DX
      MOV AX,0x04
      ADD CX,DS:[xvir]
      ADD DX,DS:[yvir]

      int 0x33
     }
}